#!/bin/sh 
USAGE="usage: $0 [-hv] -dev device"
#
#
# Initialize the specified device with ingress 
# queueing discipline.  
#
# Author:  nemo@invisiblehand.net
# Version: $Revision: 1.1 $, $Date: 2005/01/03 10:19:02 $
# $Id: init-ingress.cgi,v 1.1 2005/01/03 10:19:02 nemo Exp $

source routux.conf

case $1 in
-r) shift ;;
*)
echo Content-type: text/plain
echo
esac

usage() {
    echo $USAGE
    echo ""
}

case $1 in
-hv|-h|-vh) usage ; exit 1 ;;
-v*) VERBOSE=1 ; echo Verbose ON ; shift  ;;
*)  VERBOSE=0 ;;
esac

############ default values ############

DEVICE=eth0

############ parse command line parameters ############

case $# in
0) echo ERROR ; usage ; exit 1;;
2) 
	while [ $# -gt 0 ] 
	    do
		case $1 in
		    -dev)   DEVICE=$2   ;;
                    *) echo ERROR wrong argument $1 ; exit 1;;
		esac
		shift 2
	    done ;;

*) echo ERROR ; usage ; exit 1;;
esac

if [ $VERBOSE -eq 1 ]; then 
    echo interface:     $DEVICE
fi

############ Initialize root class ############
# root handle is 

RET=`$TC qdisc add dev $DEVICE ingress 2>&1`
QDISC_EXISTS="RTNETLINK answers: File exists"

#if [ .$RET = .${QDISC_EXISTS} ]; then
if [ -n "$RET" ] ; then
    if [ $VERBOSE -eq 1 ]; then 
	echo  $DEVICE "ingress qdisc seems to exist, deleting it."
    fi
    $TC qdisc del dev $DEVICE ingress 2>&1
    RET=`$TC qdisc add dev $DEVICE ingress 2>&1`
fi
if [ -n "$RET" ] ; then
    echo ERROR $DEVICE cannot create qdisc: $RET
    exit 1
fi

echo SUCCESS $DEVICE

exit
