#!/bin/sh 
USAGE="usage: $0 [-hv] -dev device"
#
#
# Show ingress filters (and associated policers) on the specified device 
#
# Author:  nemo@invisiblehand.net
# Version: $Revision: 1.1 $, $Date: 2005/01/03 10:19:02 $
# $Id: show-ingress.cgi,v 1.1 2005/01/03 10:19:02 nemo Exp $

source routux.conf

case $1 in
-r) shift ;;
*)
echo Content-type: text/plain
echo
esac

usage() {
    echo $USAGE
    echo ""
}

case $1 in
-hv|-h|-vh) usage ; exit 1 ;;
-v*) VERBOSE=1 ; echo Verbose ON ; shift  ;;
*)  VERBOSE=0 ;;
esac

############ parse command line parameters ############

case $# in
0) echo ERROR ; usage ; exit 1;;
2) 
	while [ $# -gt 0 ] 
	    do
		case $1 in
		    -dev)   DEVICE=$2   ;;
                    *) echo ERROR wrong argument $1 ; exit 1;;
		esac
		shift 2
	    done ;;

*) echo ERROR ; usage ; exit 1;;
esac

if [ $VERBOSE -eq 1 ]; then 
    echo interface:     $DEVICE
    echo 
fi

$TC filter show dev $DEVICE parent ffff:

echo SUCCESS $DEVICE

exit
